{*******************************************************}
{                                                       }
{              XmlSqlDb Component Library               }
{       Pal Sitkei (sitkei@chello.hu, 2004.11.13)       }
{                                                       }
{*******************************************************}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, ExtCtrls, DB, ComCtrls, XmlSqlDb;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    Edit1: TEdit;
    Memo1: TMemo;
    PageControl1: TPageControl;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    XmlSqlDb1: TXmlSqlDb;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses FolderBrowser;

procedure TForm1.Button1Click(Sender: TObject);    //browse
var FB: TFolderBrowser;
begin
  FB:= TFolderBrowser.Create(Self);
  FB.Folder:= Edit1.Text;
  if FB.Execute then Edit1.Text:= FB.Folder+ '\';
  FB.Free;
end;

procedure TForm1.Button2Click(Sender: TObject);   //run
begin
  TTabSheet(PageControl1.ActivePage).Caption:=
     Copy(TMemo(TTabSheet(PageControl1.ActivePage).Controls[0]).Lines.Text, 1, 12);
  XmlSqlDb1.Close;
  XmlSqlDb1.DataBase:= Edit1.Text;
  XmlSqlDb1.Sql:= TMemo(PageControl1.ActivePage.Controls[0]).Lines.Text;
  XmlSqlDb1.Open;
  Memo1.Text:= XmlSqlDb1.LogText;
  Button5.Enabled:= XmlSqlDb1.CanUndo;
  if XmlSqlDb1.ErrorStr<>'' then ShowMessage(XmlSqlDb1.ErrorStr);
end;

procedure TForm1.Button3Click(Sender: TObject);   //new tab
var TS: TTabSheet;
begin
  TS:= TTabSheet.Create(Self);
  TS.PageControl:= PageControl1;
  TS.Caption:= 'Empty';
  with TMemo.Create(Self) do
  begin
    Parent:= TS;
    Align:= alClient;
    ScrollBars:= ssVertical;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);   //save tabs
var i: Integer;
begin
  for i:= 0 to PageControl1.PageCount- 1 do
    tMemo(TTabSheet(PageControl1.Controls[i]).Controls[0]).Lines.SavetoFile(ExtractFilePath(Application.ExeName)+'sql\query'+IntToStr(i)+'.sql');
end;

procedure TForm1.Button5Click(Sender: TObject);  //undo
begin
  XmlSqlDb1.Undo;
  Button5.Enabled:= XmlSqlDb1.CanUndo;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i: Integer;
    AP: String;
    TS: TTabSheet;
    ME: TMemo;
begin
  i:= 0;
  AP:= ExtractFilePath(Application.ExeName);
  while FileExists(AP+ 'sql\query'+IntToStr(i)+'.sql') do
  begin
    TS:= TTabSheet.Create(Self);
    TS.PageControl:= PageControl1;
    ME:= TMemo.Create(Self);
    with ME do
    begin
      Parent:= TS;
      Align:= alClient;
      Lines.LoadFromFile(AP+'sql\query'+IntToStr(i)+'.sql');
      ScrollBars:= ssVertical;
    end;
    TS.Caption:= Copy(ME.Lines.Text, 1, 12);
    Inc(i);
  end;
  Edit1.Text:= AP+ 'data\testdb\';
  Button5.Enabled:= False;
end;

end.
